package client;

import java.util.Properties;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import ejb.HelloBeanRemote;

public class Client {

    public static void main(String[] args) throws NamingException {
        for(int i = 0; i < Integer.MAX_VALUE; i++) {
            InitialContext ctx = new InitialContext(getCtxProperties());
            String lookupName = "ejb:/server/HelloBean!ejb.HelloBeanRemote";
            HelloBeanRemote bean = (HelloBeanRemote)ctx.lookup(lookupName);
            System.out.println(bean.hello());
            ((Context)ctx.lookup("ejb:")).close();
            ctx.close();
        }
    }

    public static Properties getCtxProperties() {
        Properties props = new Properties();
        props.put("org.jboss.ejb.client.scoped.context", true);
        props.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
        props.put("remote.connections", "main");

        props.put("remote.connection.main.host", "127.0.0.1");
        props.put("remote.connection.main.port", "8443");
        props.put("remote.connection.main.protocol", "https-remoting");
        props.put("remote.connection.main.username", "joe");
        props.put("remote.connection.main.password", "joeIsAwesome2013!");
        props.put("remote.connection.main.connect.options.org.xnio.Options.SSL_ENABLED", "true");
        props.put("remote.connection.main.connect.options.org.xnio.Options.SASL_DISALLOWED_MECHANISMS", "JBOSS-LOCAL-USER");
        props.put("remote.connection.main.connect.options.org.xnio.Options.READ_TIMEOUT", "5000");
        props.put("remote.connection.main.connect.options.org.xnio.Options.WRITE_TIMEOUT", "5000");
        props.put("remote.connection.main.connect.options.org.xnio.Options.KEEP_ALIVE", "true");
        props.put("remote.connection.main.connect.options.org.jboss.remoting3.RemotingOptions.HEARTBEAT_INTERVAL", "1000");

        /*
        props.put("remote.connection.main2.host", "127.0.0.2");
        props.put("remote.connection.main2.port", "8443");
        props.put("remote.connection.main2.protocol", "https-remoting");
        props.put("remote.connection.main2.username", "joe");
        props.put("remote.connection.main2.password", "joeIsAwesome2013!");
        props.put("remote.connection.main2.connect.options.org.xnio.Options.SSL_ENABLED", "true");
        props.put("remote.connection.main2.connect.options.org.xnio.Options.SASL_DISALLOWED_MECHANISMS", "JBOSS-LOCAL-USER");
        props.put("remote.connection.main2.connect.options.org.xnio.Options.READ_TIMEOUT", "5000");
        props.put("remote.connection.main2.connect.options.org.xnio.Options.WRITE_TIMEOUT", "5000");

        props.put("remote.clusters", "ejb");
        props.put("remote.cluster.ejb.username", "joe");
        props.put("remote.cluster.ejb.password", "joeIsAwesome2013!");
        props.put("remote.cluster.ejb.connect.options.org.xnio.Options.SSL_ENABLED", "true");
//        props.put("remote.cluster.ejb.connect.options.org.xnio.Options.SASL_POLICY_NOPLAINTEXT", "false");
//        props.put("remote.cluster.ejb.connect.options.org.xnio.Options.SASL_POLICY_NOANONYMOUS", "false");
//        props.put("remote.cluster.ejb.connect.options.org.xnio.Options.READ_TIMEOUT", "1000");
        props.put("remote.cluster.ejb.connect.options.org.xnio.Options.KEEP_ALIVE", "true");
        props.put("remote.cluster.ejb.connect.options.org.jboss.remoting3.RemotingOptions.HEARTBEAT_INTERVAL", "1000");
        props.put("remote.cluster.ejb.port", "8443");
        props.put("remote.cluster.ejb.protocol", "https-remoting");*/
        return props;
    }

}
